// A CharFileReader object reads characters one by one from a text file

// Working version developed in class Wednesday, February 14

import java.util.Scanner;
import java.io.File;
import java.io.EOFException;
import java.io.FileNotFoundException;

public class CharFileReader {

    // instance variables
    private Scanner in;
    private String buffer;
    private int position;
    private int numCharsRemaining;
    private int charCount;

    // constructor
    public CharFileReader(String filename) throws FileNotFoundException {
        this.in = new Scanner(new File(filename));
        this.fillBuffer();
        this.charCount = 0;
    }
    
    // private helper method
    private void fillBuffer() {
        if (this.in.hasNextLine()) {
            // fill internal buffer
            this.buffer = this.in.nextLine() + '\n';
            this.position = 0;
            this.numCharsRemaining = this.buffer.length();
        } else {
            // leave buffer empty
            this.buffer = "";
            this.position = 0;
            this.numCharsRemaining = 0;
        }
    }

    public char readChar() throws EOFException {
        if (this.numCharsRemaining == 0) {
            throw new EOFException("end of file encountered");
        } else {
            char ch = this.buffer.charAt(this.position);
            this.position++;
            this.numCharsRemaining--;
            if (this.numCharsRemaining == 0) {
                this.fillBuffer();
            }
            this.charCount++;
            return ch;
        }
    }

    public boolean hasNextChar() {
        if (this.numCharsRemaining == 0) {
            return false;
        } else {
            return true;
        }
    }

    public void close() {
        this.in.close();
    }

    public int getCharCount() {
        return this.charCount;
    }
}
